import sys
sys.path
DEBUG = 1
import os
import random
import time
import re
# selenium相关
from selenium.webdriver.common.action_chains import ActionChains
from selenium.webdriver.chrome.options import Options
from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.support import expected_conditions as EC
from selenium.webdriver.support.ui import WebDriverWait

from bs4 import BeautifulSoup
from pyquery import PyQuery as pq

from datetime import datetime, timedelta
import dateparser

#-------------------------------------------------------
# 持久化相关

import pySql as DB
from answerModel import AnswerModal

#-------------------------------------------------------
# 模拟浏览器向下滑
def scrolldown(self):
    last_height = self.page_source
    loop_scroll=True
    attempt = 0
    while loop_scroll:
        self.execute_script("window.scrollTo(0, document.body.scrollHeight);")
        time.sleep(2)
        self.execute_script("window.scrollBy(0,-200)")
        time.sleep(1)
        self.execute_script("window.scrollBy(0,-200)")
        time.sleep(1)
        new_height=self.page_source
        if new_height == last_height:
            # in case of not change, we increase the waiting time
            attempt += 1
            # 尝试三遍后，停止
            if attempt==3:
                loop_scroll=False
        else:
            attempt=0
        last_height=new_height

# -------------------------------------------------------------
# 作者信息

def getRelativeCountry(browser,url):    
    browser.get(url)
    d = pq(browser.page_source)
    infomation = d(".qu-mb--medium span").text()
    a = []

    pattern_1 = re.compile(r'Active in [a-zA-Z]+')  
    pattern_2 = re.compile(r'Lives in [a-zA-Z]+')
    result_list1 = pattern_1.findall(infomation)
    for i in result_list1:
        a.append(i.replace('Active in',"").strip())
    result_list2 = pattern_2.findall(infomation)
    # 以lives开头的字段
    for i in result_list2:
        a.append(i.replace('Lives in',"").strip())
    return a


# -------------------------------------------------------------
# 搜索回答并保存到数据库中

def getAnswer(browser,questionURL):
    if DEBUG==1:print('开始答案爬取...')
    # 如果没有回答，则直接跳过
    if '/unanswered/' in str(questionURL):
        print('该问题暂无回答')        
        browser.quit()
        return 

    question_id = questionURL
    try:
        browser.get(questionURL)
        time.sleep(10)
    # 3秒后打不开，则换下一个链接    
    except Exception as OpenEx:
        print('打不开此URL : ',questionURL)
        print('错误发生在 {}'.format(sys.exc_info()[-1].tb_lineno), type(OpenEx).__name__, OpenEx)
        print(str(OpenEx)) 
        browser.quit()       
        return 
    try:
        nb_answers = 0
        nb_answers_text = WebDriverWait(browser, 10).until(
        EC.visibility_of_element_located((By.XPATH, "//div[text()[contains(.,'Answer')]]"))).text
        if(nb_answers_text != None):
            nb_answers=[int(s.strip('+')) for s in nb_answers_text.split() if s.strip('+').isdigit()][0]
            print('该问题下的答案数量为 :', nb_answers_text)
        else:
            browser.quit()
            return
    #  未知错误
    except Exception as Openans: 
        print('得不到答案')
        print('错误发生在 {}'.format(sys.exc_info()[-1].tb_lineno), type(Openans).__name__, Openans)
        print(str(Openans))
        browser.quit()
        return     
    if nb_answers>7:
        scrolldown(browser)
    continue_reading_buttons = browser.find_elements_by_xpath("//a[@role='button']")
    time.sleep(2)
    for button in continue_reading_buttons:
        try:
            ActionChains(browser).click(button).perform()
            time.sleep(1)
        except:
            print('cant click more')
            
            
    time.sleep(2)
    html_source = browser.page_source
    question_id = questionURL.rsplit('/', 1)[-1]    
    
    # 跳过匿名的
    try:
        split_html = html_source.split('class="q-box qu-pt--medium qu-pb--medium"')
    
    # 问题被删除
    except Exception as notexist :
        print('问题被删除')
        print('错误发生在 {}'.format(sys.exc_info()[-1].tb_lineno), type(notexist).__name__, notexist)
        print(str(notexist)) 
        browser.quit()
        return        

    for i in range(1, len(split_html)):
        try:
            part = split_html[i]
            part_soup = BeautifulSoup(part,"html.parser" )
            #开始找作者信息
            try:                
                authors = part_soup.find("a", href=lambda href: href and "/profile/" in href)                    
            #很可能是被删了
            except Exception as notexist2 :
                print('问题被删除')
                print('问题发生在 {}'.format(sys.exc_info()[-1].tb_lineno), type(notexist2).__name__, notexist2)
                print(str(notexist2))
                browser.quit()
                return 
                                
            # 搜索回答时间
            # 将时间转化为 yyyy-mm-dd 的格式
            answer_date= part_soup.find("a", string=lambda string: string and ("Answered" in string or "Updated" in string))#("a", {"class": "answer_permalink"})
            try:
                date=answer_date.text
                if ("Updated" in date):
                   date= date[8:]
                else:
                   date= date[9:]
                date=dateparser.parse(date).strftime("%Y-%m-%d")
            except:                 
                date=dateparser.parse("7 days ago").strftime("%Y-%m-%d")

            # 回答的内容主体
            answer_text = part_soup.find("div", {"class": "q-relative spacing_log_answer_content"})
            answer_text = answer_text.text
            
            #持久化          
            answer = AnswerModal(str(question_id.rstrip()),str(answer_text.rstrip()), str(date),authors['href'].replace("/profile/",""),"[" + ','.join(getRelativeCountry(browser,"https://www.quora.com" + authors['href'])) + "]")          
            # answer.travel()
            DB.insert(answer)
        except Exception as e1: 
            # 匿名处理
            print('---------------发生异常-----------')
            print('错误发生在 {}'.format(sys.exc_info()[-1].tb_lineno), type(e1).__name__, e1)
            print(str(e1))
            browser.quit()
            return 

    browser.quit()