from connectChrome import connectchrome
from bs4 import BeautifulSoup
import os
import datetime
import time
import csv
import sys

Debug = True

# 开始时间
start_time = datetime.datetime.now()

# 自动化测试模组
driver = connectchrome()

try:
    url = "https://www.quora.com/topic/China/all_questions"
    
    # 打开指定的链接
    driver.get(url) 

    if Debug: print(driver.page_source)
    if Debug: driver.quit()
except Exception as e0:
    print('话题不存在')        
    driver.quit()

question_count_soup = BeautifulSoup(driver.page_source, 'html.parser')
    
#  获取问题的总数
question_count_str = question_count_soup.find('a', attrs={'class': 'TopicQuestionsStatsRow'})
if str(question_count_str)=='None':
    print('该话题下，没有问题...')
    driver.quit()
    exit
question_count = question_count_str.contents[0].text

# 将k转化为1000
if 'k' in str(question_count):
    question_count = str(question_count).replace('k','')
    question_count = int(float(question_count)*1000)

print('关于中国的话题有 : '+ str(question_count))

# 获得页面高度
last_height = driver.execute_script("return document.body.scrollHeight")

if int(question_count)>10: 
    start_time_sd = time.time()
    max_time=  int(question_count)*0.25
    if int(question_count)> 8000:
        max_time=1800
    while True:
        scrolling_attempt = 0
        scroll_waiting_time = 2
        # 尝试三次，以免科学上网问题，导致速度慢
        while True:
            print('往下拉... ',scrolling_attempt)
            # 下拉，高度为整个页面的高度
            driver.execute_script("window.scrollTo(0, document.body.scrollHeight);")
            # 等待页面加载
            time.sleep(scroll_waiting_time)
            # 得到页面高度
            new_height = driver.execute_script("return document.body.scrollHeight")        
            
            ##### = ？
            if new_height != last_height:
               break                           
            scrolling_attempt+=1
            if scrolling_attempt==1:
                scroll_waiting_time = 4
            elif scrolling_attempt==2:
                if int(question_count)>2000:
                    scroll_waiting_time = 15
                elif int(question_count)>500:
                    scroll_waiting_time = 7
                else : 
                    break
            else : 
                break
        # 没法往下拉的时候，退出循环
        if new_height == last_height:  
            break
        last_height = new_height
        # 如果超时，则不爬了
        total_time = time.time() - start_time_sd
        if total_time> max_time:
            print('尝试了很多次，还是失败了')
            break

# 当模拟下拉结束以后，获得整个界面的源代码
print('开始解析内容 ...')

html_source = driver.page_source
soup = BeautifulSoup(html_source, 'html.parser')

question_link = soup.find_all('a', attrs={'class': 'question_link'}, href=True)

# 数组
question_set = set()
for ques in question_link:
    question_set.add(ques)

# 写入txt文件中
questions_directory = 'topics/'
os.makedirs('topics/', exist_ok=True)
file_name = questions_directory + '/' + '2_question_urls.txt'
file_question_urls = open(file_name, mode='w', encoding='utf-8')
writer = csv.writer(file_question_urls)

for ques in question_set:
    link_url = "http://www.quora.com" + ques.attrs['href']
    writer.writerows([[link_url]])

driver.quit()

# 花费的时间
end_time = datetime.datetime.now()
print(' 已完成，花费的时间为  : ',end_time-start_time)
