$(document).ready(function(){
  countiesName = ['Papua New Guinea','Angola','Cambodia','Sudan','Kazakhstan','Paraguay','Portugal','New Caledonia','Bahamas','Cayman Islands','Greece','Latvia','Mongolia','Iran','Morocco','Guadeloupe','Panama','Guatemala','Iraq','Chile','Nepal','Argentina','Isle of Man','Tanzania','Ukraine','Belize','Ghana','Zambia','Bahrain','Congo','India','Canada','Turkey','Belgium','Namibia','Faroe Islands','Finland','Taiwan','South Africa','Trinidad and Tobago','Georgia','Jamaica','Peru','Germany','Puerto Rico','Hong Kong','Guinea','United States','Aruba','Madagascar','Thailand','Libya','Costa Rica','Sweden','Vietnam','Andorra','Liechtenstein','Poland','Bulgaria','Kuwait','Nigeria','Tunisia','Republic of Korea','Croatia','Sri Lanka','Uruguay','United Kingdom','United Arab Emirates','Kenya','Switzerland','French Polynesia','Palestine','Spain','Brunei','Lebanon','Azerbaijan','Cuba','Venezuela','Czech Republic','Saint Lucia','Swaziland','Mayotte','Israel','San Marino','Australia','Estonia','Cameroon','Cyprus','Malaysia','Iceland','Oman','Armenia','Gabon','Austria','Mozambique','El Salvador','Luxembourg','Brazil','Guam','Algeria','Slovenia','Antigua and Barbuda','Colombia','Ecuador','Hungary','Japan','Belarus','Mauritius','Albania','New Zealand','Senegal','Honduras','Italy','Macedonia','Haiti','Afghanistan','Singapore','Egypt','Republic of Lithuania','Bolivia','Malta','Russia','Saudi Arabia','Netherlands','Pakistan','Kosovo','China','Ireland','Martinique','U.S. Virgin Islands','Slovakia','France','Serbia','Bosnia and Herzegovina','Romania','Philippines','Bangladesh','Barbados','Nicaragua','Norway','Botswana','Myanmar [Burma]','Denmark','Dominican Republic','Hashemite Kingdom of Jordan','Mexico','Zimbabwe','Suriname','Republic of Moldova','Greenland','Montenegro','Indonesia']
  let getDateUrl = "https://map.qdu.life/getEmotion";
  $("#datePicker").dateRangeSlider({
    bounds: {min: new Date(2015, 1, 1), max: new Date(2020, 11, 12, 12, 59, 59)},
    defaultValues: {min: new Date(2015, 1, 1), max: new Date(2016, 4, 22)},
    symmetricPositionning: false,
    valueLabels: "change",
    scales: [{
      first: function(value){ return value; },
      end: function(value) {return value; },
      next: function(value){
        var next = new Date(value);
        return new Date(next.setMonth(value.getMonth() + 1));
      },
      format: function(tickContainer, tickStart, tickEnd){
        tickContainer.addClass("myCustomClass");
      }
    }]
  });

  //绑定事件
  $("#datePicker").on("valuesChanged", function(e, data){
    let min = new Date(data.values.min).pattern("yyyy-MM-dd");
    let max = new Date(data.values.max).pattern("yyyy-MM-dd");
    query(min,max)    
  });
       
 // 对Date的扩展，将 Date 转化为指定格式的String       
  Date.prototype.pattern=function(fmt) {           
      var o = {           
      "M+" : this.getMonth()+1, //月份           
      "d+" : this.getDate(), //日           
      "h+" : this.getHours()%12 == 0 ? 12 : this.getHours()%12, //小时           
      "H+" : this.getHours(), //小时           
      "m+" : this.getMinutes(), //分           
      "s+" : this.getSeconds(), //秒           
      "q+" : Math.floor((this.getMonth()+3)/3), //季度           
      "S" : this.getMilliseconds() //毫秒           
      };           
      var week = {           
      "0" : "/u65e5",           
      "1" : "/u4e00",           
      "2" : "/u4e8c",           
      "3" : "/u4e09",           
      "4" : "/u56db",           
      "5" : "/u4e94",           
      "6" : "/u516d"          
      };           
      if(/(y+)/.test(fmt)){           
          fmt=fmt.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length));           
      }           
      if(/(E+)/.test(fmt)){           
          fmt=fmt.replace(RegExp.$1, ((RegExp.$1.length>1) ? (RegExp.$1.length>2 ? "/u661f/u671f" : "/u5468") : "")+week[this.getDay()+""]);           
      }           
      for(var k in o){           
          if(new RegExp("("+ k +")").test(fmt)){           
              fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));           
          }           
      }           
      return fmt;           
  }         

  function getRandomArbitrary(min, max) {
    return Math.random() * (max - min) + min;
  }

  function getRandomInt(min, max) {
      min = Math.ceil(min);
      max = Math.floor(max);
      return Math.floor(Math.random() * (max - min + 1)) + min;
  }

  $(".country").hover(function(){
    var gmt_country = $(this).attr("id");
    $(this).attr("data-content", "开发中");
    var options = {
        format:'<span class=\"dt\">%A, %d %B %I:%M:%S %P</span>',
        timeNotation: '12h',
        am_pm: true,
        utc:true,
        utc_offset: gmt_country
      };
  }); 

  $('[data-toggle="popover"]').popover({ trigger: "hover" }); 

  function init(){
    for(let i = 0;i<countiesName.length;i++){
      let contryName = countiesName[i];
      let coutry = document.querySelectorAll('[data-name="' + contryName + '"]')[0];       
      if(coutry != undefined ){
        coutry.style.fill = "white";
      }
      coutry = document.querySelectorAll('[data-name="China"]')[0].style.fill="#fdd365"
    }
  }
  
  function fillColor(countryName,color){      
      let coutry = document.querySelectorAll('[data-name="' + countryName + '"]')[0];
      if(coutry != undefined ){
        coutry.style.fill = color;
      }
  }
  
  function query(startTime,endTime){
    $.ajax({
      url: getDateUrl + "/" + startTime + "/" + endTime,
      type: "GET",     
      success:function(result){
        console.log(result)
        json = jQuery.parseJSON(result);
        for(country in json){
          let emotion = json[country];          
            if(emotion>=1){
              fillColor(country,"#FF2800")
              continue;
            }            
            if(emotion>=0.4){
              fillColor(country,"#BF4630")
              continue;
            }
            if(emotion>0.2){
              fillColor(country,"#FF8973")
              continue;
            }
            if(emotion>0){
              fillColor(country,"#EEE8AA")
              continue;
            }  
            if(emotion<=-1){
              fillColor(country,"#238C47")
              continue;
            }               
            if(emotion<=-0.4){
              fillColor(country,"#00BB3F")
              continue;
            }            
            if(emotion<0){
            fillColor(country,"#00BB3F")
            continue;
            }
        }        
        coutry = document.querySelectorAll('[data-name="China"]')[0].style.fill="#fdd365"
      },    
    });
  }

  $("#title").click(function(){
    window.location.href="https://blog.qdu.life";
  });
});


