package qdu.life.service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.springframework.stereotype.Service;
import qdu.life.Utils.JsonUtil;
import qdu.life.mapper.CityMapper;

import org.springframework.beans.factory.annotation.Autowired;

import qdu.life.model.City;
import qdu.life.model.SimpleEmotion;

import java.sql.Date;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

@Service
public class CityService {

  @Autowired
  CityService service;

  @Autowired
  CityMapper mapper;

  public String getCountry(String city){
    return  mapper.getCountry(city);
  }

  public String getEmotion(String startTime,String endTime) throws ParseException {
    SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd");
    List<SimpleEmotion> date =  mapper.getEmotion(sdf.parse(startTime),sdf.parse(endTime));
    Map<String, Double> resultMap = new HashMap<String,Double>();
    for (SimpleEmotion emotion : date) {
      if(emotion.getRelativeCountry() == "") continue;
      if(resultMap.containsKey(emotion.getRelativeCountry())){
        //如果存在，则将他们累加
        resultMap.put(emotion.getRelativeCountry(), resultMap.get(emotion.getRelativeCountry()) + emotion.getEmotion());
      }else{
        //map中不存在，新建key，用来存放数据
        resultMap.put(emotion.getRelativeCountry(), emotion.getEmotion());
      }
    }
    String jSONObject=JSONObject.toJSONString(resultMap);
    return  jSONObject;
  }


  public void saveJson() {
    JsonUtil jsonUtil = new JsonUtil();
    String json = jsonUtil.getData();
    JSONObject jsonObject = JSON.parseObject(json);
    Set<String> allCountries = jsonObject.keySet();

    for (String country : allCountries) {

      String jsonStr = jsonObject.get(country).toString();
      JSONArray cityArr = JSONArray.parseArray(jsonStr);
      City city = new City();

      if(cityArr.size()>0) {
        for (int i = 0; i < cityArr.size(); i++) {
          Object job = cityArr.get(i);

          city.setCity(job.toString());
          city.setCountry(country);
      mapper.save(city.getCity(),city.getCountry());
        }
      }
    }
  }

    }


